# This file configures the analyzer, which statically analyzes Dart code to
# check for errors, warnings, and lints.
#
# The issues identified by the analyzer are surfaced in the UI of Dart-enabled
# IDEs (https://dart.dev/tools#ides-and-editors). The analyzer can also be
# invoked from the command line by running `flutter analyze`.

# The following line activates a set of recommended lints for Flutter apps,
# packages, and plugins designed to encourage good coding practices.
include: package:flutter_lints/flutter.yaml

analyzer:
  errors:
    must_be_immutable: ignore
  exclude:
    - lib/**/*.g.dart
  language:
    strict-casts: true
    strict-inference: true
    strict-raw-types: true

linter:
  # The lint rules applied to this project can be customized in the
  # section below to disable rules from the `package:flutter_lints/flutter.yaml`
  # included above or to enable additional rules. A list of all available lints
  # and their documentation is published at
  # https://dart-lang.github.io/linter/lints/index.html.
  #
  # Instead of disabling a lint rule for the entire project in the
  # section below, it can also be suppressed for a single line of code
  # or a specific dart file by using the `// ignore: name_of_lint` and
  # `// ignore_for_file: name_of_lint` syntax on the line or in the file
  # producing the lint.
  rules:
    # Error rules
    # discarded_futures: true # I do this a lot and to not do so would be difficult
    prefer_single_quotes: true
    cancel_subscriptions: true
    close_sinks: true
    prefer_relative_imports: true
    avoid_void_async: true
    throw_in_finally: true
    avoid_dynamic_calls: true
    no_adjacent_strings_in_list: true
    no_self_assignments: true
    no_wildcard_variable_uses: true
    unnecessary_statements: true

    # Style rules
    always_declare_return_types: true
    avoid_js_rounded_ints: true
    avoid_setters_without_getters: true
    cascade_invocations: true
    only_throw_errors: true
    prefer_final_in_for_each: true
    prefer_final_locals: true
    prefer_final_parameters: true
    unawaited_futures: true
    unnecessary_await_in_return: true
    unnecessary_parenthesis: true
    use_if_null_to_convert_nulls_to_bools: true
    use_named_constants: true
    use_super_parameters: true
# Additional information about this file can be found at
# https://dart.dev/guides/language/analysis-options
